package livecld;

import java.util.ArrayList;

import livecld.actions.DeleteElementAction;
import livecld.actions.ExtendAction;
import livecld.actions.GefActionUtil;
import livecld.actions.GefRenameAction;
import livecld.actions.OpenElementAction;

import org.eclipse.gef.ContextMenuProvider;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jdt.core.IMember;
import org.eclipse.jdt.core.IType;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.viewers.IStructuredSelection;


public class HierarchyViewContextMenuProvider extends ContextMenuProvider {
	private HierarchyViewPart viewPart;
	
	
	public HierarchyViewContextMenuProvider(HierarchyViewPart viewPart) {
		super(viewPart.getGraphicalViewer());
		
		this.viewPart = viewPart;
	}

	@Override
	public void buildContextMenu(IMenuManager menu) {		
		GEFActionConstants.addStandardActionGroups(menu);
		
		ArrayList<IMember> memberList = new ArrayList<IMember>();
		
		for (Object object : GefActionUtil.convertToModelList((IStructuredSelection) getViewer().getSelection())) {
			if (object instanceof IMember) {
				IMember member = (IMember) object;
				memberList.add(member);
			}
		}
		
		if (memberList.size() >= 1) {
			IMember element = memberList.get(memberList.size()-1);

			menu.add(new OpenElementAction(element));
			
			if (element instanceof IType) {
				menu.add(new ExtendAction(viewPart.getSite(), (IType)element));
			}
			
			menu.add(new Separator());
			menu.add(new GefRenameAction(viewPart.getSite(), element));
			menu.add(new DeleteElementAction(element));
			menu.add(new Separator());			
		}

		viewPart.getStandardActionGroup().fillContextMenu(menu);
	}
	
}
