package livecld;

import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;

public class TextProvider {
	
	private static TextProvider instance = new TextProvider();
	
	public static TextProvider getInstance() {
		return instance;
	}
	
	private TextProvider() {
		
	}
	
	public String getText(IType type) {
		return type.getElementName();
	};

	public String getText(IField field) {
		StringBuffer sb = new StringBuffer();
		
		try {
			sb.append(Signature.toString(field.getTypeSignature()));
			sb.append(" ");
			sb.append(field.getElementName());
		} catch (JavaModelException e) {
			e.printStackTrace();
		}
		
		return sb.toString();
	};
	
	
	public String getText(IMethod method) {
		StringBuffer sb = new StringBuffer();
		
		try {
			if (!method.isConstructor())
				sb.append(Signature.toString(method.getReturnType()) + " ");
			
			sb.append(method.getElementName());
			
			sb.append("(");
			
			String paramTypes[] = method.getParameterTypes();
			String paramNames[] = method.getParameterNames();
			
			for (int i = 0; i < method.getNumberOfParameters(); i++) {
				if (i != 0)
					sb.append(", ");
				
				sb.append(Signature.toString(paramTypes[i]));
				sb.append(" ");
				sb.append(paramNames[i]);
			}
			
			sb.append(")");
		} catch (JavaModelException e) {
			e.printStackTrace();
		}
		
		return sb.toString();
	};
	
}
