package livecld.actions;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IWorkspaceRunnable;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.OperationCanceledException;
import org.eclipse.jdt.core.IPackageFragmentRoot;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.ui.wizards.NewClassWizardPage;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.wizard.Wizard;

public class NewClassWizard extends Wizard {
	private NewClassWizardPage page;

	public NewClassWizard(IType extendType) {
		page = new NewClassWizardPage();

		if (!extendType.isBinary()) {
			page.setPackageFragmentRoot((IPackageFragmentRoot) extendType.getPackageFragment().getParent(), true);
			page.setPackageFragment(extendType.getPackageFragment(), true);			
		}

		String name = extendType.getFullyQualifiedName();
		page.setSuperClass(name.replaceAll("\\$","\\."), false);


		addPage(page);
	}

	@Override
	public boolean performFinish() {

		final IWorkspaceRunnable op = new IWorkspaceRunnable() {
			public void run(IProgressMonitor monitor) throws CoreException, OperationCanceledException {
				try {
					page.createType(monitor);
				} catch (InterruptedException e) {
					throw new OperationCanceledException(e.getMessage());
				}
			}
		};
		
		
		final IRunnableWithProgress runnable = new IRunnableWithProgress() {
			public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
				try {
					JavaCore.run(op, ResourcesPlugin.getWorkspace().getRoot(), monitor);
				} catch (Exception e) {
					throw new OperationCanceledException(e.getMessage());
				}
			}
		};

		try {
			getContainer().run(true, true, runnable);
		} catch (InvocationTargetException e) {
			return false;
		} catch (InterruptedException e) {
			return false;
		}
		return true;
	}
}