package livecld.actions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.ui.JavaUI;
import org.eclipse.jface.action.Action;
import org.eclipse.ui.IEditorPart;

public class OpenElementAction extends Action {
	private List<? extends IJavaElement> elements;
	
	public OpenElementAction(IJavaElement ...elements) {
		ArrayList<IJavaElement> list = new ArrayList<IJavaElement>(elements.length);
		
		for (IJavaElement e : elements) {
			list.add(e);
		}
		
		init(list);		
	}
	
	public OpenElementAction(List<? extends IJavaElement> elements) {
		init(elements);
	}
	
	private void init(List<? extends IJavaElement> elements) {
		this.elements = elements;
		
		setText("Open");
		
		if (elements == null || elements.size() < 1)
			setEnabled(false);
	}
	
	@Override
	public void run() {
		for (IJavaElement element : elements) {
			try {
				IEditorPart editor = JavaUI.openInEditor(element);
				JavaUI.revealInEditor(editor, element);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
