package livecld.controller;

import java.util.List;

import livecld.model.DiagrammRootModel;
import livecld.view.DiagrammRootFigure;

import org.eclipse.draw2d.ConnectionLayer;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.ShortestPathConnectionRouter;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.LayerConstants;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.gef.editpolicies.RootComponentEditPolicy;
import org.eclipse.swt.SWT;




public class DiagrammRootEditPart extends AbstractGraphicalEditPart {
	protected IFigure createFigure() {
		IFigure f = new DiagrammRootFigure();

		// add the router
		ConnectionLayer connLayer = (ConnectionLayer)getLayer(LayerConstants.CONNECTION_LAYER);
		
		
		if ((getViewer().getControl().getStyle() & SWT.MIRRORED) == 0)
			connLayer.setAntialias(SWT.ON);
		
		ShortestPathConnectionRouter spRouter = new ShortestPathConnectionRouter(f);
		connLayer.setConnectionRouter(spRouter);
		
		return f;
	}
	
	@Override
	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new RootComponentEditPolicy());
		installEditPolicy(EditPolicy.SELECTION_FEEDBACK_ROLE, null);
	}
	
	@Override
	public List getModelChildren() {
		return getCastedModel().getChildren();
	}
	
	public DiagrammRootModel getCastedModel() {
		return (DiagrammRootModel)getModel();
	}
	
	
	private int visibility;
	
	public void setVisibility(int i) {
		visibility = i;
	}
	
	public int getVisibility() {
		return visibility;
	}
	
	private boolean showBinaryMembers;

	public boolean isShowBinaryMembers() {
		return showBinaryMembers;
	}

	public void setShowBinaryMembers(boolean showBinaryMembers) {
		this.showBinaryMembers = showBinaryMembers;
	}
	
	
	
}
