package livecld.controller;

import java.util.ArrayList;
import java.util.List;

import livecld.model.HierarchyNodeModel;
import livecld.view.HierarchyNodeFigure;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;


public class HierarchyNodeEditPart extends AbstractGraphicalEditPart {

	Object dummyTypeModel = new Object();
	Object dummyChildrenModel = new Object();
	
	@Override
	protected IFigure createFigure() {
		HierarchyNodeFigure f = new HierarchyNodeFigure();
		return f;
	}

	
	@Override
	public List getModelChildren() {
 		List<Object> list = new ArrayList<Object>();
 		list.add(dummyTypeModel);
 		list.add(dummyChildrenModel);
 		return list;
	}
	

	
	@SuppressWarnings("unchecked")
	@Override
	protected EditPart createChild(Object model) {
		HierarchyCompartmentEditPart part = new HierarchyCompartmentEditPart();
		List compartmentChildren = null;
		
		if (model == dummyTypeModel) {
			compartmentChildren = new ArrayList(1);
			compartmentChildren.add(getCastedModel().getType());
		} else if (model == dummyChildrenModel) {
			List<HierarchyNodeModel> list = getCastedModel().getChildren();
			
			compartmentChildren = list;
		}
		
		part.setCompartmentModelChildren(compartmentChildren);
		part.setModel(model);
		return part;
	}
	
	
	


	@Override
	public IFigure getContentPane() {
		return getCastedFigure().getContentPane();
	}
	
	
	public HierarchyNodeModel getCastedModel() {
		return (HierarchyNodeModel)getModel();
	}
	
	public HierarchyNodeFigure getCastedFigure() {
		return (HierarchyNodeFigure)getFigure();
	}
	

	@Override
	protected void createEditPolicies() {

	}

}
