package livecld.controller;

import java.util.ArrayList;
import java.util.List;

import livecld.HierarchyModelProvider;
import livecld.view.MemberCompartmentFigure;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.jdt.core.IMember;


public abstract class MemberCompartmentEditPart extends AbstractGraphicalEditPart {
	@Override
	protected IFigure createFigure() {
		return new MemberCompartmentFigure();
	}
	
	@Override
	protected abstract List getModelChildren();
	
	
	@Override
	public IFigure getContentPane() {
		return ((MemberCompartmentFigure)getFigure()).getContentPane();
	}

	@Override
	protected void createEditPolicies() {
		// TODO Auto-generated method stub
	}
	
	
	protected List filter(IMember members[]) {
		ArrayList<IMember> filtered = new ArrayList<IMember>();
		
		int visibility = ((DiagrammRootEditPart)getRoot().getContents()).getVisibility();

		for (IMember member : members) {
			if (HierarchyModelProvider.getVisibility(member) >= visibility)
				filtered.add(member);
		}
		
		return filtered;
	}
	
}
