package livecld.model;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jdt.core.IType;

public class HierarchyNodeModel extends AbstractModel {
	private ArrayList<HierarchyNodeModel> children = new ArrayList<HierarchyNodeModel>();
	private IType typeModel;
	
	private HierarchyNodeModel parent;
	
	
	/** List of outgoing Connections. */
	private List<GeneralizationConnectionModel> sourceConnections = new ArrayList<GeneralizationConnectionModel>();
	/** List of incoming Connections. */
	private List<GeneralizationConnectionModel> targetConnections = new ArrayList<GeneralizationConnectionModel>();
	
	
	public List<GeneralizationConnectionModel> getSourceConnections() {
		return sourceConnections;
	}
	
	public List<GeneralizationConnectionModel> getTargetConnections() {
		return targetConnections;
	}
	
	
	public HierarchyNodeModel(IType typeModel) {
		this.typeModel = typeModel;
	}
	
	public HierarchyNodeModel getParent() {
		return parent;
	}
	
	public void detach() {
		for (GeneralizationConnectionModel conn : parent.getTargetConnections()) {
			if (conn.getTarget() == this.getType())
				parent.getTargetConnections().remove(conn);
		}
		
		parent.getChildren().remove(this);
		parent = null;
	}
	
	private void setParent(HierarchyNodeModel parent) {
		this.parent = parent;
		
		GeneralizationConnectionModel conn = new GeneralizationConnectionModel(parent.getType(), this.getType());
		sourceConnections.add(conn);
		parent.addTargetConnection(conn);
	}
	
	private void addTargetConnection(GeneralizationConnectionModel econn) {
		targetConnections.add(econn);
	}
	
	
	
	public IType getType() {
		return typeModel;
	}
	
	public void addChild(HierarchyNodeModel n) {
		n.setParent(this);
		children.add(n);
	}
	
	public List<HierarchyNodeModel> getChildren() {
		return children;
	}
	
	@Override
	public boolean equals(Object o) {
		if (o instanceof HierarchyNodeModel)
			return getType().equals(((HierarchyNodeModel)o).getType());
		else
			return false;
	}
	

	
}
