package livecld.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Layer;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Insets;

public class MemberCompartmentFigure extends Layer {

	private IFigure contentPane = new Figure();

	public MemberCompartmentFigure() {
		setLayoutManager(new ToolbarLayout());

		ToolbarLayout layout = new ToolbarLayout();
		layout.setMinorAlignment(ToolbarLayout.ALIGN_TOPLEFT);
		layout.setStretchMinorAxis(false);
		layout.setSpacing(2);
		contentPane.setLayoutManager(layout);

		add(contentPane);

		setBorder(new CompoundBorder(new CompartmentFigureBorder(), new MarginBorder(3)));
		setOpaque(false);
		
//		setBorder(new CompoundBorder(new FrameBorder(getClass().getSimpleName()), new MarginBorder(5)));
	}


	public class CompartmentFigureBorder extends MarginBorder {

		CompartmentFigureBorder() {
			super(5, 3, 3, 1);
		}

		public void paint(IFigure f, Graphics g, Insets i) {
			org.eclipse.draw2d.geometry.Rectangle r = getPaintRectangle(f, i);
			g.setForegroundColor(ColorConstants.black);
			g.drawLine(r.x, r.y, r.right(), r.y);
		}
	}

	public IFigure getContentPane() {
		return contentPane;
	};

}
