package livecld.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.ToolbarLayout;

public class MessageFigure extends Figure {
	private Label label;
	private IFigure contentPane = new Figure();
	
	public MessageFigure(String message) {
		setLayoutManager(new ToolbarLayout());
		
		label = new Label(message);
		contentPane.add(label);
		
		FlowLayout layout = new FlowLayout(FlowLayout.HORIZONTAL);
		layout.setMajorAlignment(FlowLayout.ALIGN_CENTER);
		layout.setMajorSpacing(50);
		contentPane.setLayoutManager(layout);
		
		add(contentPane);
		
		setBorder(new MarginBorder(50,5,50,5));
		label.setBorder(new CompoundBorder(new LineBorder(ColorConstants.gray), new MarginBorder(10)));
	}
	
	
	public IFigure getContentPane() {
		return contentPane;
	};
	
}
