package livecld.view;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.Panel;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;

public class TypeFigure extends Panel {
	public static final Color classColor = new Color(null, 255, 255, 206);

	private Label titleLabel = new Label();

	private IFigure contentPane = new Figure();
	
	
	public TypeFigure() {
		setLayoutManager(new ToolbarLayout());
		
		ToolbarLayout layout = new ToolbarLayout();
		contentPane.setLayoutManager(layout);
		
		
		setBorder(new LineBorder(ColorConstants.black, 1));
		setBackgroundColor(classColor);
		setOpaque(true);
		
		titleLabel.setBorder(new MarginBorder(4,3,1,3));


		add(titleLabel);
		add(contentPane);
		
		setMinimumSize(new Dimension(100,100));
		setMaximumSize(new Dimension(200,getMaximumSize().height));
	}

	public void setText(String title) {
		titleLabel.setText(title);
	}
	
	public void setIcon(Image image) {
		titleLabel.setIcon(image);
	}
	
	public IFigure getContentPane() {
		return contentPane;
	}
	
}